// FRAM-Treiber   Dr. Weisser 15.3.2019     16.3.2019
//fm24c64.h

#ifndef FM24C64_H_
#define FM24C64_H_

#define FM24C64  1    // 1: FM24C64       0: kein FM24C64 

#if FM24C64 // FRAM mit 4.5-5.5V
// FM24C64: I2C-Adresse
//                                 A2
//                                  A1
//                                   A0
//                                    R=1/W=0
#define FRAM_ADR_W   0xA0  // 1010 0000 FM24C64 Schreiben
#define FRAM_ADR_R   0xA1  // 1010 0001 FM24C64 Lesen
/*
#define FRAM_ADR_W   0xA2  // 1010 0010 FM24C64 Schreiben
#define FRAM_ADR_R   0xA3  // 1010 0011 FM24C64 Lesen
#define FRAM_ADR_W   0xA4  // 1010 0100 FM24C64 Schreiben
#define FRAM_ADR_R   0xA5  // 1010 0101 FM24C64 Lesen
#define FRAM_ADR_W   0xA6  // 1010 0110 FM24C64 Schreiben
#define FRAM_ADR_R   0xA7  // 1010 0111 FM24C64 Lesen
#define FRAM_ADR_W   0xA8  // 1010 1000 FM24C64 Schreiben
#define FRAM_ADR_R   0xA9  // 1010 1001 FM24C64 Lesen
#define FRAM_ADR_W   0xAA  // 1010 1010 FM24C64 Schreiben
#define FRAM_ADR_R   0xAB  // 1010 1011 FM24C64 Lesen
#define FRAM_ADR_W   0xAC  // 1010 1100 FM24C64 Schreiben
#define FRAM_ADR_R   0xAD  // 1010 1101 FM24C64 Lesen
#define FRAM_ADR_W   0xAE  // 1010 1110 FM24C64 Schreiben
#define FRAM_ADR_R   0xAF  // 1010 1111 FM24C64 Lesen
*/

#endif // FM24C64


// Funktionsprototypen


void fram_adr(unsigned int adr);  // Slave, Adresse fuer Schreiben/Lesen ueber I2C-Bus 
void fram_wr(unsigned char byte); // ein byte schreiben auf Slave, ab Adresse 
unsigned char fram_rd(void);      // ein byte lesen von Slave, ab Adresse 
void fram_test(void);             // FRAM-Test: Schreiben, Lesen 


#endif
