//***************************************************************************
//  File........: int.c
//  Target(s)...: ATmega328p
//  Compiler....: AVR-GCC
//  Description.: AVR Interrupts
//                Interrupt-Tabelle in io.h -> iom328p.h
//                ISR-Tabelle auch erstellen mit
// $ echo | avr-gcc -mmcu=atmega328 -g3 -xc - -include avr/io.h -E -dM | grep _vect\b | sort
//***************************************************************************

#include <avr/io.h>
#include "out.h"
#include <avr/interrupt.h>
#include <avr/pgmspace.h>


/****************************************************************************
*  Function Name :  ISR_BADISR
*  Returns :        none
*  Parameters :     none
*  Purpose :        Interrupt service routine for unexpected Interrupt
*
* vgl. WinAVR-20100110/doc/avr-libc/avr-libc-user-manual/group__avr__interrupts.html
* Catch-all interrupt vector
*****************************************************************************/
ISR(BADISR_vect)
{
   outs(USART,PSTR("unerwart. Interrupt")); // get command character from UART receive register
}

