// LCD-Treiber   Dr. Weisser 15.11.2016  26.2.2019
// lcd44780.h

#ifndef LCD44780_H_
#define LCD44780_H_

// hd44780-Display im 4-bit mode
#define LCD_LINES             4  // Zeilen
#define LCD_DISP_LENGTH      20  // Zeichen pro Zeile

                                 // DB7 =I/O
                                 //  DB6 =I/O
                                 //   DB5 =I/O
                                 //    DB4 =I/O
                                 //      LEDoff =out
                                 //       E     =out
                                 //        R/W  =out
                                 //         RS  =out
#define LCD_RESET          0x30  // 0011 0000

#define LCD_RS             0x01  // 0000 0001 RS bit (RegisterSelect)
                                 //   RS=1 schreibt/liest CGRAM/DDRAM
#define LCD_READ           0x02  // 0000 0010 Read bit
#define LCD_E              0x04  // 0000 0100 Enable bit
#define LCD_LED_ON         0x08  // 0000 1000 LED bit
#define LCD_LED_OFF        0x00  // 0000 0000 LED bit

// commands
#define LCD_CLR            0x01  // lt. Datenblatt
#define LCD_CLR_H          0x00  // 0000 0000 hi-byte
#define LCD_CLR_L          0x10  // 0001 0000 low-byte

#define LCD_HOME           0x02  // lt. Datenblatt
#define LCD_HOME_H         0x00  // 0000 0000 hi-byte
#define LCD_HOME_L         0x20  // 0010 0000 low-byte

#define LCD_ENTRY          0x04  // lt. Datenblatt
#define LCD_ENTRY_H        0x00  // 0000 0000 hi-byte
#define LCD_ENTRY_L        0x40  // 0100 0000 lo-byte
// flags
#define LCD_ENTRYINC       0x02  // lt. Datenblatt Schreibstelle rechts
#define LCD_ENTRYINC_H     0x00  // 0000 0000
#define LCD_ENTRYINC_L     0x20  // 0010 0000
#define LCD_ENTRYDEC       0x00  // lt. Datenblatt Schreibstelle links
#define LCD_ENTRYDEC_H     0x00  // 0000 0000
#define LCD_ENTRYDEC_L     0x00  // 0000 0000
#define LCD_ENTRYDSHIFT    0x01  // lt. Datenblatt Displayshift
#define LCD_ENTRYDSHIFT_H  0x00  // 0000 0000
#define LCD_ENTRYDSHIFT_L  0x10  // 0001 0000

#define LCD_DISPCTRL       0x08  // lt. Datenblatt
#define LCD_DISPCTRL_H     0x00  // 0000 0000
#define LCD_DISPCTRL_L     0x80  // 1000 0000
// flags
#define LCD_DISPON         0x04  // lt. Datenblatt
#define LCD_DISPON_H       0x00  // 0000 0000
#define LCD_DISPON_L       0x40  // 0100 0000
#define LCD_DISPOFF        0x00  // lt. Datenblatt
#define LCD_DISPOFF_H      0x00  // 0000 0000
#define LCD_DISPOFF_L      0x00  // 0000 0000
#define LCD_CURSON         0x02  // lt. Datenblatt
#define LCD_CURSON_H       0x00  // 0000 0000
#define LCD_CURSON_L       0x20  // 0010 0000
#define LCD_CURSOFF        0x00  // lt. Datenblatt
#define LCD_CURSOFF_H      0x00  // 0000 0000
#define LCD_CURSOFF_L      0x00  // 0000 0000
#define LCD_BLINKON        0x01  // lt. Datenblatt
#define LCD_BLINKON_H      0x00  // 0000 0000
#define LCD_BLINKON_L      0x10  // 0001 0000
#define LCD_BLINKOFF       0x00  // lt. Datenblatt
#define LCD_BLINKOFF_H     0x00  // 0000 0000
#define LCD_BLINKOFF_L     0x00  // 0000 0000

#define LCD_CURSSHIFT      0x10  // lt. Datenblatt
#define LCD_CURSSHIFT_H    0x10  // 0001 0000
#define LCD_CURSSHIFT_L    0x00  // 0000 0000
// flags
#define LCD_DISPLAYMOVE    0x08  // lt. Datenblatt
#define LCD_DISPLAYMOVE_H  0x00  // 0000 0000
#define LCD_DISPLAYMOVE_L  0x80  // 1000 0000
#define LCD_CURSORMOVE     0x00  // lt. Datenblatt
#define LCD_CURSORMOVE_H   0x00  // 0000 0000
#define LCD_CURSORMOVE_L   0x00  // 0000 0000
#define LCD_MOVERIGHT      0x04  // lt. Datenblatt
#define LCD_MOVERIGHT_H    0x00  // 0000 0000
#define LCD_MOVERIGHT_L    0x40  // 0100 0000
#define LCD_MOVELEFT       0x00  // lt. Datenblatt
#define LCD_MOVELEFT_H     0x00  // 0000 0000
#define LCD_MOVELEFT_L     0x00  // 0000 0000

#define LCD_FUNCTION       0x20  // lt. Datenblatt
#define LCD_FUNCTION_H     0x20  // 0010 0000
#define LCD_FUNCTION_L     0x00  // 0000 0000
// flags
#define LCD_8BITMODE       0x10  // lt. Datenblatt
#define LCD_8BITMODE_H     0x10  // 0001 0000
#define LCD_8BITMODE_L     0x00  // 0000 0000
#define LCD_4BITMODE       0x00  // lt. Datenblatt
#define LCD_4BITMODE_H     0x00  // 0000 0000
#define LCD_4BITMODE_L     0x00  // 0000 0000
#define LCD_2LINE          0x08  // lt. Datenblatt
#define LCD_2LINE_H        0x00  // 0000 0000
#define LCD_2LINE_L        0x80  // 1000 0000
#define LCD_1LINE          0x00  // lt. Datenblatt
#define LCD_1LINE_H        0x00  // 0000 0000
#define LCD_1LINE_L        0x00  // 0000 0000
#define LCD_5x10DOTS       0x04  // lt. Datenblatt
#define LCD_5x10DOTS_H     0x00  // 0000 0000
#define LCD_5x10DOTS_L     0x04  // 0100 0000
#define LCD_5x8DOTS        0x00  // lt. Datenblatt
#define LCD_5x8DOTS_H      0x00  // 0000 0000
#define LCD_5x8DOTS_L      0x00  // 0000 0000

#define LCD_SETCGRAMADR    0x40  // lt. Datenblatt
#define LCD_SETCGRAMADR_H  0x40  // 0100 0000
#define LCD_SETCGRAMADR_L  0x00  // 0000 0000

// Zeichen im DDRAM
// nicht fuer Zeichenausgabe genutzter Speicher als RAM nutzbar
#define LCD_SETDDRAMADR    0x80  // lt. Datenblatt
#define LCD_SETDDRAMADR_H  0x80  // 1000 0000
#define LCD_SETDDRAMADR_L  0x00  // 0000 0000
                                 //   7 Adressleitungen:
                                 //   DB6
                                 //    DB5
                                 //     DB4
                                 //      DB3
                                 //       DB2
                                 //        DB1
                                 //         DB0
                                 //  000 0000 =0x00
                                 //  111 1111 =0x7F
                                 //  =128 Zeichen max. darstellbar
                                 //  4 Zeilen x 20 Zeichen=80 Zeichen
                                 //  -> 48 RAM-Stellen ungenutzt
                                 // 1000 0000 =0x80
                                 // 1111 1111 =0xFF
#define LCD_START_LINE1    0x00  // DDRAM Adresse 1. Zeichen Zeile 1
#define LCD_START_LINE1_H  0x00  // 0000 0000
#define LCD_START_LINE1_L  0x00  // 0000 0000
#define LCD_START_LINE2    0x40  // DDRAM Adresse 1. Zeichen Zeile 2
#define LCD_START_LINE2_H  0x40  // 0100 0000
#define LCD_START_LINE2_L  0x00  // 0000 0000
#define LCD_START_LINE3    0x14  // DDRAM Adresse 1. Zeichen Zeile 3
#define LCD_START_LINE3_H  0x10  // 0001 0000
#define LCD_START_LINE3_L  0x04  // 0100 0000
#define LCD_START_LINE4    0x54  // DDRAM Adresse 1. Zeichen Zeile 4
#define LCD_START_LINE4_H  0x50  // 0101 0000
#define LCD_START_LINE4_L  0x40  // 0100 0000
// fuer Linien-Adressen siehe lcd_dworkin.c Michael Dworkin


// globale Variable zum Schalten LED-Backlight ein/aus
unsigned char led;
//led=LCD_LED_OFF;  // Display-LED defaultmaessig aus bei gelbem Display.
//led=LCD_LED_ON;   // Display-LED defaultmaessig ein bei blauem Display !
//Funktionen lcd_led_on, lcd_led_off benutzen !!!


// Funktionsprototypen

unsigned char PCF8574_read(void);  // PCF-Pins einlesen

void PCF8574_write(unsigned char); // PCF-Pins ausgeben

void lcd_init(void);     // LCD init
void lcd_clear(void);    // LCD loeschen
void lcd_home(void);     // an erste Schreibposition
void lcd_on(void);       // LCD-Anzeige einschalten
void lcd_off(void);      // LCD-Anzeige abschalten
void lcd_cur_on(void);   // Cursor einschalten
void lcd_cur_off(void);  // Cursor abschalten
void lcd_led_on(void);   // Hintergrundbeleuchtung einschalten
void lcd_led_off(void);  // Hintergrundbeleuchtung abschalten

void lcd_write(unsigned char cmddata, unsigned char steuer); // Kommando an LCD senden
void lcd_defchar(void);  // eigene Zeichen definieren

void lcd_xy(unsigned char zeile,unsigned char pos);  // Schreibstelle festlegen

void lcd_test(void);     // LCD-Test

#endif // LCD44780_H_
