// main.h

#ifndef MAIN_H_
#define MAIN_H_

// Public Functions (used in menu.h and others)
void initialization(void); 

// CPU-Frequenz fuer delay festlegen, wird auch im Makefile definiert und in delay.h
#ifndef F_CPU  // falls noch nicht definiert 
#define F_CPU   16000000   // 16MHz Quarz auf Platine Arduino nano3, atmega2560, atmega32u4 
//#define F_CPU    8000000   // interner 8MHz-RC-Oszillator im Chip atmega32u2 
//#define F_CPU    1000000   // interner 8MHz-RC-Oszillator + CLKDIV8-Fuse aktiv atmega32u2 
#endif // F_CPU 

// CPU-Prescaler einstellen: erst vorderstes bit, dann Aenderung ! 
#define CPU_PRESCALE(n) (CLKPR = 0x80, CLKPR = (n)) 


#define BOOL    char

#define FALSE   0
#define TRUE    (!FALSE)
#define NULL ((void *)0)

// Macro definitions
// ( GNU compatibility Macros )

#ifndef sbi
    #define _BV(bit)            (1 << (bit))
    #define sbi(x,bit)          (x |= _BV(bit)) // set bit  ( GNU compatability )
    #define cbi(x,bit)          (x &= ~_BV(bit)) // clear bit  ( GNU compatability )
#endif
#ifndef bit_is_set
    #define bit_is_set(sfr, bit) (sfr & _BV(bit))
    #define bit_is_clear(sfr, bit) (!(sfr & _BV(bit)))
#endif



// Global Variables defined in main.c
//
//extern unsigned char gDataPosition; // position in page of next write to df
//extern unsigned int gDataPage;      // current page to be written to the flash


#endif
